<template>
  <div class="content">
    <vue-confirm-dialog></vue-confirm-dialog>
    <h3 class="h2" style="margin-top: 65px;">
      <i class="fa fa-book" style="padding-right: 10px; font-size: 40px"></i
      ><strong>Mata Kuliah KOTA</strong>
    </h3>
    <!-- <h4>Tabel Mata Kuliah KOTA</h4> -->
    <div
      class="main"
      style="border-radius: 20px; margin-top: 30px; min-height: 400px; box-shadow: 5px 5px #c5c5c5; padding-bottom: 30px"
    >
      <div
        class="main main-raised"
        style="border-radius: 50px; float:right; top: 45px; right: 20px; height: 0px"
      >
        <a
          href="#/dashboard/mata-kuliah-create"
          class="md-list-item-router md-layout gradient2"
          style="border-radius: 50px; box-shadow: 5px 5px #c5c5c5"
        >
          <md-button
            class="md-button1 md-simple"
            style="height: 40px; width: 200px;"
          >
            <!-- <p style="color: white; font-size: 20px; padding: 10px 7px 0px 0px">
              +
            </p> -->
            <span
              style="color: white; font-size: 14px; text-transform: capitalize"
            >
              Tambah Mata Kuliah
            </span>
          </md-button>
        </a>
      </div>
      <md-table
        v-model="mataKuliahList"
        md-sort="name"
        md-sort-order="asc"
        style="padding: 20px 50px 0px 50px; border-radius: 20px;"
        md-fixed-header
      >
        <md-table-toolbar style="padding-left: 10px">
          <div class="md-toolbar-section-start">
            <md-field
              style="margin-left: 0px; padding: 5px 0px 0px 0px; max-width: 300px;"
            >
              <label>Pilih Prodi...</label>
              <md-select
                name="prodi.id"
                id="prodi.id"
                v-model="selectedProdi"
                @input="searchOnTable"
                md-dense
                style="border: 0px"
              >
                <md-option
                  v-for="(prodi, key) in prodiList"
                  :key="key"
                  :value="prodi.id"
                  style="width:100%; left: 10px;"
                >
                  {{ prodi.singkatan_prodi }} - {{ prodi.nama_prodi }}
                </md-option>
              </md-select>
            </md-field>
          </div>
        </md-table-toolbar>

        <md-table-row slot="md-table-row" slot-scope="{ item }">
          <!-- <md-table-cell md-label="" md-sort-by="" md-numeric> </md-table-cell> -->
          <!-- <md-table-cell md-label="Periode" md-sort-by="periode" style="width: 80px;">
            {{ item.periode.tahun }}-{{ item.periode.semester }}
          </md-table-cell> -->
          <md-table-cell md-label="Kode" md-sort-by="kode_mk">
            {{ item.kode_mk }}
          </md-table-cell>
          <md-table-cell
            md-label="Nama Mata Kuliah"
            md-sort-by="mata_kuliah.nama_mk"
          >
            {{ item.nama_mk }}
          </md-table-cell>
          <md-table-cell md-label="SKS" md-sort-by="sks_mk">
            {{ item.sks_mk }}
          </md-table-cell>
          <md-table-cell
            md-label="Prodi"
            md-sort-by="prodi.singkatan_prodi"
            style="padding-left: 30px"
          >
            {{ item.prodi.singkatan_prodi }} - {{ item.prodi.nama_prodi }}
          </md-table-cell>
          <md-table-cell>
            <router-link
              :to="{
                name: 'mata-kuliah-update',
                params: { id: item.id }
              }"
            >
              <i
                class="fa fa-edit"
                aria-hidden="true"
                style="
                color: #0b76e0;
                font-size: 18px;
              "
                ><md-tooltip md-direction="bottom"
                  >Update Mata Kuliah</md-tooltip
                ></i
              >
            </router-link>
          </md-table-cell>
          <md-table-cell>
            <md-button
              type="submit"
              class="md-simple md-danger"
              style="height: 20px;"
              @click="onDelete(item.id)"
            >
              <i
                class="fa fa-times"
                aria-hidden="true"
                style="font-size: 20px !important"
                ><md-tooltip md-direction="bottom"
                  >Delete Mata Kuliah</md-tooltip
                ></i
              >
            </md-button>
          </md-table-cell>
        </md-table-row>
      </md-table>
    </div>
    <md-progress-bar md-mode="indeterminate" v-if="sending" />

    <md-snackbar :md-active.sync="userSaved"
      >Proses menghapus berhasil</md-snackbar
    >
  </div>
</template>

<script>
import { mapState, mapActions } from "vuex";
// import moment from "moment";

const toLower = text => {
  return text.toString().toLowerCase();
};

// const searchByPeriode = (items, term) => {
//   if (term) {
//     return items.filter(item =>
//       toLower(item.periode.id).includes(toLower(term))
//     );
//   }
//   return items;
// };

// const searchByProdi = (items, term) => {
//   if (term) {
//     return items.filter(item =>
//       toLower(item.mata_kuliah.prodi.id).includes(searchByPeriode(term))
//     );
//   }
//   return items;
// };

export default {
  components: {},
  bodyClass: "login-page",
  //   data() {},
  data: () => ({
    total: "",
    classicModal: false,
    search: "x",
    search1: "x",
    searched: [],
    selectedProdi: ""
  }),
  props: {
    header: {
      type: String,
      default: require("@/assets/img/gedung-upj.jpg")
    },
    image: {
      type: String,
      default: require("@/assets/img/bg-red-batik.png")
    },
    logo: {
      type: String,
      default: require("@/assets/img/logo/upj-logo.png")
    }
  },
  computed: {
    ...mapState("mataKuliah", ["mataKuliahList"]),
    ...mapState("prodi", ["prodiData", "prodiList"]),
    headerStyle() {
      return {
        backgroundImage: `url(${this.image})`
      };
    }
  },
  methods: {
    ...mapActions("mataKuliah", ["getMataKuliahList", "deleteMataKuliah"]),
    ...mapActions("prodi", ["getProdi", "getProdiList"]),
    async onFetchData() {
      await this.getMataKuliahList();
      await this.getProdiList();
    },
    onDelete(id) {
      this.$confirm({
        message: `Yakin ingin menghapus data Mata Kuliah?`,
        button: {
          no: "Batal",
          yes: "Ya"
        },
        /**
         * Callback Function
         * @param {Boolean} confirm
         */
        callback: confirm => {
          if (confirm) {
            try {
              this.deleteMataKuliah({
                id: id
              });
              window.setTimeout((this.userSaved = true), 2000);
              this.sending = false;
              this.onFetchData();
              // this.$router.push({ name: "report-mata-kuliah-kaprodi" });
            } catch (error) {
              throw Error(error);
            }
            // ... do something
          }
        }
      });
    },
    onResponsiveInverted() {
      if (window.innerWidth < 600) {
        this.responsive = true;
      } else {
        this.responsive = false;
      }
    },
    searchOnTable() {
      this.getMataKuliahList({
        prodi_id: this.selectedProdi
      });
      // this.searched = searchByPeriode(this.laporanList, this.search);
    },
    classicModalHide() {
      this.classicModal = false;
    }
  },
  async mounted() {
    await this.onFetchData();
    // this.onResponsiveInverted();
    window.addEventListener("resize", this.onResponsiveInverted);
  },
  created() {
    this.searched = this.mataKuliahList;
  }
};
</script>

<style lang="scss" scoped></style>

<style lang="css"></style>
